/* 
 * File:   main.c
 * Author: saka
 *
 * Created on 2015/05/20, 23:03
 */
#include <xc.h>
#define _XTAL_FREQ  10000000

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG
#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = OFF       // Watchdog Timer (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (Power-up Timer is enabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled)

// EEPROM Setting
__EEPROM_DATA(0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10);
__EEPROM_DATA(0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18);
__EEPROM_DATA(0x1c, 0x1c, 0x1c, 0x1c, 0x1c, 0x1c, 0x1c, 0x1c);
__EEPROM_DATA(0x1e, 0x1e, 0x1e, 0x1e, 0x1e, 0x1e, 0x1e, 0x1e);

#include <stdio.h>
#include <stdlib.h>
#include "lcd4.h"

void putch(unsigned char c) {         // define putch() for standard i/o functions
    Putc_LCD4(c);
}

void levelmeter(int i){
    int x,y;
    x = i/5;
    y = i%5;
    for(i=0;i<x;i++){
        putchar(0xff);
    }
    if(y){
        putchar(y-1);
    }
    putchar(' ');
}
printnum(unsigned char i){
    putchar(0x30+i/10);
    putchar(0x30+i%10);
    Set_DDA(0x40);
}

int main(void) {
    INTCON=0x0;
    TRISA=0x1;                  // RA is assigned to serial port
    PORTA=0x0;
    TRISB=0x0;                  // RB is assigned to LCD
    PORTB=0x0;

    unsigned char i;

    Init_LCD4();

    for(i=0;i<4;i++){                   // set CGRAM character using EEPROM
        ROM2CGRAM(i, 8*i);
    }

    unsigned char mho[]={0x00, 0x00, 0x1b, 0x0a, 0x11, 0x11, 0x0e, 0x00};
    for(i=0;i<8;i++){                   // set CGRAM character
        CGRAM_LCD4(4,&mho);
    }


    while(1){
        MoveHome_LCD4;
        printf("0123456789abcdefghijklmnopqrstuvwxyz");
        Set_DDA(0x40);
        printf("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ");
        for(i=0;i<20;i++){
            __delay_ms(100);
            Shift_L;
        }
        for(i=0;i<20;i++){
            __delay_ms(100);
            Shift_R;
        }
        Clr_LCD4;
        for(i=1;i<80;i++){              // displays level meter
            MoveHome_LCD4;
            //printf("%02d\n",i);
            printnum(i);
            levelmeter(i);
            __delay_ms(80);
        }
        for(i=79;i>0;i--){              // displays level meter
            MoveHome_LCD4;
            //printf("%02d\n",i);
            printnum(i);
            levelmeter(i);
            __delay_ms(80);
        }
    }
 
    return (EXIT_SUCCESS);
}

